using Lada.Framework.Infrastructures.Helpers;
using Ladaer.BackEnd.Infrastructures.DTO.Models.Categories;
using Ladaer.BackEnd.Infrastructures.DTO.Models.Orders.Shared;
using Ladaer.BackEnd.Infrastructures.Services.Crm;
using Ladaer.BackEnd.Infrastructures.Services.Orders;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;

namespace Ladaer.BackEnd.Controllers.Orders
{
    /// <summary>
    /// Controller xử lý các hoạt động liên quan đến địa chỉ đơn hàng.
    /// </summary>
    [Route("api/[controller]")]
    [ApiController]
    [Authorize]
    public class OrderAddressController : ControllerBase
    {
        private readonly IOrderAddressService _orderAddressService;
        private readonly ICustomerService _customerService;
        /// <summary>
        /// Khởi tạo một instance mới của lớp <see cref="OrderAddressController"/>.
        /// </summary>
        /// <param name="orderAddressService">Dịch vụ xử lý địa chỉ đơn hàng.</param>
        public OrderAddressController(IOrderAddressService orderAddressService, ICustomerService customerService)
        {
            _orderAddressService = orderAddressService;
            _customerService = customerService;
        }

        /// <summary>
        /// Lấy thông tin chi tiết của một địa chỉ đơn hàng dựa trên ID.
        /// </summary>
        /// <param name="id">ID của địa chỉ đơn hàng.</param>
        /// <returns>Thông tin chi tiết của địa chỉ đơn hàng.</returns>
        [HttpGet("GetById")]
        [Authorize(Roles = "OrderAddress.GetById")]
        public async Task<IActionResult> GetById(int id)
        {
            var result = await _orderAddressService.GetById(id);
            return Ok(result);
        }

        /// <summary>
        /// Cập nhật thông tin địa chỉ đơn hàng.
        /// </summary>
        /// <param name="model">Model chứa thông tin địa chỉ đơn hàng.</param>
        /// <returns>Kết quả của hoạt động cập nhật.</returns>
        [HttpPut("Update")]
        [Authorize(Roles = "OrderAddress.Update")]
        public async Task<IActionResult> Update([FromBody] UpdateOrderAddressModel model)
        {
            if (!ModelState.IsValid)
            {
                return BadRequest(ModelState);
            }
            var currentUser = User.GetCurrentUser();
            model.UpdatedBy = currentUser.UserId;
            model.UpdatedByUserName = currentUser.UserName;
            if (model.UpdatedBy <= 0 || string.IsNullOrEmpty(model.UpdatedByUserName))
            {
                return BadRequest("Không xác định được người dùng");
            }

            var result = await _orderAddressService.Update(model);
            return Ok(result);
        }
    }
}
